@php
    const HTTP_POST = 'POST';
    const HTTP_GET = 'GET';
    const HTTP_PUT = 'PUT';
    const HTTP_PATCH = 'PATCH';
    const HTTP_DELETE = 'DELETE';

    $methodSpoofing = [HTTP_PUT, HTTP_PATCH, HTTP_DELETE];
    $supportedMethods = array_merge([HTTP_GET, HTTP_POST], $methodSpoofing);
    $method = $method ?? HTTP_POST;

    if (!in_array($method, $supportedMethods)) {
        throw new Exception('Invalid form method!');
    }

    if (in_array($method, $methodSpoofing)) {
        $spoof = $method;
        $method = HTTP_POST;
    }
@endphp
<form action="{{ $action }}" method={{ $method }} @if(isset($files) and $files == true) enctype="multipart/form-data" @endif>
    @isset($spoof)
        @method($spoof)
    @endisset
    @if($method != HTTP_GET)
        @csrf
    @endif
    {{ $slot }}
</form>