@extends('algo::layouts.app', [
    'meta_title' => trans('algo::categories') . ' | Index'
])

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">@lang('algo::categories')</div>
                <div class="card-body">
                    @statusAlert

                    <div class="mb-4">
                        <a href="{{route('algo.categories.create') }}" class="btn btn-sm btn-outline-dark">@lang('algo::new_category')</a>
                    </div>

                    @each('algo::categories._category', $categories, 'category')
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
