<small>
    {{ $label }}
    @if (isset($locale))
        (@lang("algo::locales.{$locale}"))
    @endif
</small>

<br />

@if(isset($markdown) and $markdown == true)
    @inject('markdown', 'Parsedown')
    <div class="algo-markdown">
        {!! $markdown->parse($value) !!}
    </div>
@elseif(isset($embed) and $embed == true)
    <div class="embed-responsive embed-responsive-16by9">
        <iframe class="embed-responsive-item" src="{{ $value }}" allowfullscreen></iframe>
    </div>
    <br />
@else
    <p class="lead">
        @if (isset($link))
            <a href="{{ $link }}">{{ $value }}</a>
        @else
            {!! $value !!}
        @endif
    </p>
@endif

